<?php
/*


	graph.php
	2003-2007 Paul Geisler
	
	server side interface of MutaGraph
	
	This script is the server-side conection point of MutaGraph. Any client can connect it via
	http-GET with the parameter "action", selecting among the following functions:
	
	action=getset&name=<name> returns the ID string of the node named <name>. 
	action=getgraph ...returns the graph

*/


require_once('graph.inc.php');
require_once('parser.php');

$view=true;


function url($url, $query){
	return $url.((strpos($url, '?')>0) ? '&' : '?').$query;
}

function ud($i){
	$char=($i>0 ? 'u' : 'd');
	return str_repeat($char, abs($i));
}

function emph($t){
	$t=trim($t[0], '*');
	return '\emph{'.$t.'}';
}
function toTex($text){
	$text=preg_replace_callback("/\\*.*?\\*/",'emph',$text);
	$text=preg_replace('/\[\[_(.*?)\]\]/','$1',$text);
	$text=str_replace('_','\\_',$text);
	$text=preg_replace('/"(\b.*?\b)"/','``$1\'\'',$text);
	$text=str_replace('"', "'", $text);
	return $text;
}

function nodeRef($node, $align, $setId){

	$result = mysql_query("SELECT * FROM edge e WHERE n1={$node['id']} AND n2=$setId");
	if(mysql_fetch_row($result)) $ref=', S.\pageref{nid:'.$node['id'].'}';
	else $ref='';
		
	return '\mbox{\begin{tabular}{'.$align.'} '.toTex($node['name']).'\\\\('.toTex($node['type']).$ref.') \end{tabular}}';
}

function showNode($nodeid, $template, $setId){
	global $graph, $annotate; 
	$nodedata=$graph->getNode($nodeid);
	
	$rep['{NAME}']=toTex("$nodedata[1] $nodedata[0]  ($nodedata[2]) \\label{nid:$nodeid}");

	if($action=='selectnode' && !isset($nodeid) && isset($select)) $nodeid=$graph->getNodeID($select);			
	$rep['{ID}']=$nodeid;

	$result = mysql_query("SELECT  n.id, n.name, nt.name AS type, et.name AS edgetype FROM node n, nodetype nt, edge e, edgetype et  WHERE n.t=nt.id  AND e.n2='$nodeid' AND e.n1=n.id AND e.t=et.id");
	while ($from[] = mysql_fetch_assoc($result));
	array_pop($from);
	mysql_free_result($result);

	$result = mysql_query("SELECT  et.name AS edgetype, n.name, nt.name AS type, n.id  FROM node n, nodetype nt, edge e, edgetype et WHERE n.t=nt.id  AND e.n1='$nodeid' AND e.n2=n.id AND e.t=et.id");
	while ($to[]   = mysql_fetch_assoc($result)); 
	array_pop($to);
	mysql_free_result($result);

	$i=0;

	$mid='';
	$i=0;
	/*foreach ($from as $f){
		$d=str_repeat('d', $i++);
	}*/
	
	$mid.='\mbox{'.toTex($nodedata[0]).' ('.toTex($nodedata[1]).')}';
	
	$i=0;
/*	foreach ($to   as $f){
		$d=str_repeat('d',$i++);
		$mid.=' \ar[r'.$d.']|{\mbox{'.toTex($f['edgetype']).'}} ';
	}
*/

	$count=max(count($from), count($to));
	$center=round($count/2)-1;
	$con='';
	for ($i=0; $i<$count; $i++){
		if (isset($from[$i])) {
			$con.=nodeRef($from[$i],'r',$setId);
			$d=ud($i-$center);
			$con.=' \ar[r'.$d.']|{\mbox{'.toTex($from[$i]['edgetype']).'}} ';
		}
		$con.=' & ';
		if($i==$center) $con.=$mid;
		$con.=' & ';
		if (isset($to[$i])) {
			$con.=nodeRef($to[$i],'l',$setId);
			$d=ud($i-$center);
			$con.=' \ar@{<- }[l'.$d.']|{\mbox{'.toTex($to[$i]['edgetype']).'}} ';
		}
		$con.=" \\\\\n";
	}


	$rep['{CONNECTIONS}']=$con;

	$rep['{TEXT}']=toTex($nodedata[3]);
	$rep['{REQUEST_URI}']=$_SERVER["REQUEST_URI"];

	return template($template, $rep);
}

function icon($name){
	if (file_exists("grafik/$name.png"))
		return "<img src='grafik/$name.png'>";
	else return "($name)";
}

function linkup ($text, $marks, $ids){			
	global $WikiIndex;
	$WikiIndex=$_SERVER['SCRIPT_NAME']; 
	if ($marks){ 
		foreach ($marks as $key => $value){
			$marks[$key]='((?:^|\])[^\[]*?)('.$marks[$key].')i';
			$ids[$key]='$1 [[?action=selectnode&nodeid='.$ids[$key].' $2]]';
		}
		$text2=preg_replace($marks,$ids,$text);
	}else $text2=$text;
	$parser = new Parser(myLanguage());
	$text2 = $parser->parse($text2);
	return $text2[0].'<br>'.$text2[1];
}
	

function template($file, $replacements){
	$tpl=file_get_contents($file);
	return strtr($tpl, $replacements);
}
	
$select=$_GET['select'];
if (!isset($sn)) {
	$sn=$_SERVER['REQUEST_URI'];
	$sn=preg_replace('[?]action=[^&]*i','?',$sn);
	$sn=preg_replace('[&]action=[^&]*i','',$sn);
}

$source=ucfirst($_GET['source']);
if (!strlen($source)>0) $source="SQL";
$graph=getGraph($source);
$graph->connect();
mysql_query('SET NAMES utf8');

$action=$_GET["action"];
if (!$action)  $action='frames';
switch($action){	
case 'shownode': case 'selectnode':

	if(isset($_GET["name"]))
		$nodeid=$graph->getNodeID($_GET["name"]);
	else
		$nodeid=$_GET["nodeid"];
	
	$text=showNode($nodeid, 'mutatex/template.tex');
	$tex=template('mutatex/templateAll.tex', array('{NODES}'=>$text));
	break;
case 'pages':
	$set=$_GET["set"];
	$setId=$graph->getNodeID($set);
	$r='';
	$result = mysql_query("SELECT  n.id, n.name, nt.name, et.name FROM node n, nodetype nt, edge e, edgetype et  WHERE n.t=nt.id  AND e.n2='$setId' AND e.n1=n.id AND e.t=et.id");
	while ($line = mysql_fetch_row($result)) {
 		$r.=showNode($line[0],'mutatex/template.tex',$setId);
	}
	mysql_free_result($result);
	$tex=template('mutatex/templateAll.tex', array('{NODES}'=>$r));
	break;
}
chdir('mutatex');
if(file_exists('temp.pdf')) unlink('temp.pdf');
$f=fopen('temp.tex','w');
fwrite($f, $tex);
fclose($f);
$errors=shell_exec('pdflatex temp.tex');
if(file_exists('temp.pdf')){
	header('Content-type: application/pdf');
	readfile('temp.pdf');
}
else echo $tex.$errors;
?>
