
package org.dronus.graph;

import org.dronus.graph.gui.*;



/** ImmutableGraphEltSet provides access to the elements of GraphElementSet 
  * that does not allow for addition or deletion of nodes or edges.
  *
  * @author   Alexander Shapiro                                        
  * @version  1.21  $Id: ImmutableGraphEltSet.java,v 1.12 2002/04/01 05:55:45 x_ander Exp $
  */
public interface ImmutableGraph {

    /** Return the number of Nodes in the cumulative Vector. */
    public int nodeCount();

    /** Return the number of Edges in the cumulative Vector. */
    public int edgeCount();

    /** Return the Node whose ID matches the String <tt>id</tt>, null if no match is found. */
    public LayoutableNode findNode( String id );
   /** Return an Edge spanning Node <tt>from</tt> to Node <tt>to</tt>. */
    public LayoutableEdge findEdge( LayoutableNode from, LayoutableNode to );

    /** iterates through all the nodes. */
    public void forAllNodes( GraphForEachNode fen );

    /** iterates through pairs of Nodes. */
    public void forAllNodePairs( GraphForEachNodePair fenp );
    	
    /** iterates through Edges. */
    public void forAllEdges( GraphForEachEdge fee );

} // end com.touchgraph.graphlayout.graphelements.ImmutableGraphEltSet
