
package org.dronus.graph;
import java.util.*;
import org.dronus.graph.gui.*;


public class VisibleLocality extends Locality {

    public VisibleLocality(Graph ges) {
        super(ges);
    }

    public void addEdge( LayoutableEdge edge ) {
        if(!contains(edge)) {
            super.addEdge(edge);            
            edge.from.visibleEdgeCnt++;
            edge.to.visibleEdgeCnt++;
        }
    } 

    public boolean removeEdge( LayoutableEdge edge ) {
        boolean removed = super.removeEdge(edge);
        if (removed) {
            edge.from.visibleEdgeCnt--;
            edge.to.visibleEdgeCnt--;
            //System.out.println("Ogodir meint:"+edge.from.visibleEdgeCnt+" "+edge.to.visibleEdgeCnt);
        }
        return removed;
    }
	/** Clear all nodes and edges. */
	  synchronized public void removeAll() {
	  	  Iterator it=((Collection)edges.clone()).iterator();
	  	  while (it.hasNext())
	  	  	removeEdge((LayoutableEdge)it.next());
		  super.removeAll();
	  }
} 
