
package org.dronus.graph.gui;

/** <p>An class for exceptions thrown during TouchGraph processing. </p>
  *
  * @author   Alexander Shapiro
  * @author   Murray Altheim
  * @version  1.21  $Id: TGException.java,v 1.5 2002/04/01 05:51:55 x_ander Exp $
  */
public class GraphException extends RuntimeException {

    /** An exception occurring when a Node already exists. */
    public final static int NODE_EXISTS       = 1;

    /** An exception occurring when a Node doesn't exist. */
    public final static int NODE_DOESNT_EXIST = 2;

    /** An exception occurring when a Node is missing its required ID. */
    public final static int NODE_NO_ID        = 3;


    protected int id = -1;
    public Exception exception = null;

    public GraphException( int id ) 
    {
        super();
        this.id = id;
    }

    public GraphException( int id, String message ) 
    {
        super(message);
        this.id = id;
    }

    public GraphException( Exception exception ) 
    {
        super();
	this.exception = exception;
    }

} // end com.touchgraph.graphlayout.TGException
