/*
 * Created on 18.04.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.dronus.graph.gui;


import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;

import org.dronus.graph.Graph;
import org.dronus.graph.nodefilter.*;


public class NodeSearchDialog extends Dialog {
	Graph graph;
	LayoutableNode selected;
	LayoutableNode[] select;
	List list=new List(30);
	LinkedList index=new LinkedList(); 
	TextField search=new TextField(50);
	String pattern;

	static Frame getFrame(Component c){			
			while ( c!= null && ! (c instanceof Frame ) ) c=c.getParent();
			return (Frame)c;
	}
		
	public NodeSearchDialog(Component c, Graph _graph, boolean multiselect){		
		super(getFrame(c), "Knoten suchen",true);
		graph=_graph;
		add(search,BorderLayout.NORTH);
		search.addTextListener(new TextListener(){
			public void textValueChanged(TextEvent e) {
				matchList(search.getText());
				if (list.getItemCount()>0) list.select(0);
			}
		});
		KeyListener kl = new KeyAdapter(){
		 	public void keyReleased(KeyEvent e) {
		 		switch(e.getKeyCode()){
				case KeyEvent.VK_ESCAPE:
					selected=null;
					dispose();
					break;
				case KeyEvent.VK_A:
				 	if (!e.isControlDown()) break;					
					list.setVisible(false);
					for (int i=0 ; i < list.getItemCount(); i++)
						list.select(i);
					list.setVisible(true);					
					break;
				case KeyEvent.VK_ENTER:					
					finish();
					break;
				case KeyEvent.VK_UP:					
				case KeyEvent.VK_DOWN:					
					list.requestFocus();					
					break;
		 		}
			}
		};
		
		search.addKeyListener(kl);		
		add(list);
		list.addKeyListener(kl);
		list.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				finish();		
			}
		});
		list.setMultipleMode(multiselect);
		pack();
		show();
		
	}
	
	void finish(){
		int[] indexes=list.getSelectedIndexes();
		select= new LayoutableNode[indexes.length];
		for (int i=0; i<indexes.length; i++)
			select[i]=(LayoutableNode)index.get(indexes[i]);
		selected=select[0];	
		dispose();	
	}
	
	void matchList(String s){
		final NodeFilter filter = new RegExpNodeFilter(".*"+s+".*");
		list.setVisible(false);
		list.removeAll();
		index.clear();
		graph.forAllNodes(new GraphForEachNode(){
				public void forEachNode(LayoutableNode n) {
					if (filter.match(n)) {
						list.add(n.getLabel()+" ("+n.getType()+")");
						index.add(n);
					}
				}
		});
		list.setVisible(true);		
	}
	public LayoutableNode[] getResults (){
		return select;
	}
}
