/*
 * Created on 24.04.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.dronus.graph.gui;


import java.awt.*;
import java.awt.print.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.print.StreamPrintServiceFactory;

public class PrintFrame extends Frame implements Printable {

	PrintFrame printframe=this;
	private PrinterJob       pjob;
	HashSet legende = new HashSet();
	int tiles=0;
	
	GraphPanel tgp;
	
	
	PrinterJob getPSPrinterJob(File file){
		PrinterJob p=PrinterJob.getPrinterJob();
		StreamPrintServiceFactory[] spsf=PrinterJob.lookupStreamPrintServices("application/postscript");
		try {
			p.setPrintService(spsf[0].getPrintService(new FileOutputStream(file)));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (PrinterException e) {
			e.printStackTrace();
		}		
		return p;
	}
	Panel p = new Panel(){
		public void paint(Graphics _g){			
			drawGraph (_g,getWidth(),getHeight());
		}
		public Dimension getPreferredSize(){
			return new Dimension(800,500);
		}
	};
	public PrintFrame(GraphPanel  _tgp, final boolean postscript){		
		super(!postscript?"Graph drucken":"Graph postscripten");
		tgp=_tgp;
		
		Panel buttons=new Panel(); 	
		add (buttons, BorderLayout.SOUTH);
		
		Button b;
		if (!postscript){
			pjob=PrinterJob.getPrinterJob();	
			b=new Button("Drucker");
			b.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					pjob.printDialog();
				}
			});
			buttons.add(b);
		}
		b=new Button(!postscript?"Drucken":"Postscript");
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if (postscript){
					FileDialog fd = new FileDialog(printframe);
					fd.setDirectory("");
					fd.show();
					File f=new File(fd.getDirectory()+fd.getFile());
					pjob=getPSPrinterJob(f);
				}
				
				try {
					PageFormat pf=pjob.defaultPage();
					Paper p=pf.getPaper();
					p.setImageableArea(0,0,p.getWidth(), p.getHeight());
					pf.setPaper(p);
					pf.setOrientation(PageFormat.LANDSCAPE);
					pjob.setPrintable(printframe,pf);
					pjob.print();
				} catch (PrinterException e1) {
					e1.printStackTrace();
				}
			}
		});
		buttons.add(b);
		add(p);	pack();	show();
		addWindowListener (new WindowAdapter(){
			public void windowClosing(WindowEvent e) {				
				dispose();
			}
		});		
				
	}
	
	public int print(Graphics g, PageFormat pf, int page) throws PrinterException {
		if (page!=0) return NO_SUCH_PAGE;		
		pjob.setJobName("MutaGraph");
		pjob.setPrintable(this);
		drawGraph(g,pf.getImageableWidth(), pf.getImageableHeight());
		System.out.println("tiles:"+(tiles++));
		return PAGE_EXISTS;
	}

	
	void drawGraph (Graphics _g, double w, double h){
		final Graphics2D g=(Graphics2D)_g;
		
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
		Point2D tl=tgp.getTopLeftDraw();
		Point2D br=tgp.getBottomRightDraw();
		tl.x-=50;
		AffineTransform t=new AffineTransform();			
		double scale= Math.min( w/(br.x-tl.x), h/(br.y-tl.y)); 
		t.translate(w/2,h/2);
		t.scale(scale*.9, scale*.9);
		t.translate(-(tl.x+br.x)/2 , -(tl.y+br.y)/2 );			
		
		g.transform(t);
	
		GraphForEachEdge fee = new GraphForEachEdge() {
			  public void forEachEdge( LayoutableEdge edge ) {
				  edge.paint(g, false, true);
			  }
		  };
	
		tgp.visibleLocality.forAllEdges(fee);
		
		GraphForEachNode fen = new GraphForEachNode() {
			  public void forEachNode( LayoutableNode node ) {				  
				node.paint(g,false,true);
				legende.add(node.getType());
			  }
		};		
		tgp.visibleLocality.forAllNodes(fen);
		
		Iterator i=legende.iterator();
		int y=0;
		while(i.hasNext()){
			String type= (String)i.next();
			LayoutableNode n= new LayoutableNode("0",type,type);
			n.drawx=tl.x; n.drawy=tl.y+(y++)*50;
			n.paint(g,false,true);
		}		
	}
}
