/*
 * Created on 19.03.2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.dronus.graph.gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.awt.geom.*;

import org.dronus.graph.PopupNode;
import org.dronus.hansi.Happ;
import org.dronus.hansi.LeinMap;
 
/**
 * @author Paul
*/
public class PunktNodeRenderer extends NodeRenderer implements PopupNode,ActionListener {
	LeinMap lm=null;
	static boolean expanded=false;
	final static int width=250,height=150;
	
	public PunktNodeRenderer(LayoutableNode _n){
		super(_n);
		if (lm==null){
			lm=new LeinMap("grafik.zip", new File("raster.txt"));
			//org.dronus.hansi.ImageLoader.setBaseDir("");
			lm.setOptimize(false);			
			lm.setSize(width,height);
			lm.setHUD(true);
			lm.setMipLevel(2);			
		}
		try {
			lm.setGK(n.getLabel());		
		} catch (NumberFormatException e) {
			lm=null;
		}
	} 
		
	
	public void paintNodeBody( Graphics g, int ix, int iy, boolean selected, boolean print) {
		if (!expanded) super.paintNodeBody(g,ix,iy,selected,print);
		else{
			Graphics g2=g.create(ix-width/2,iy-height/2,ix+width/2,iy+height/2);
			g2.setClip(new Ellipse2D.Double( 0,0,width,height)); 
			if (!selected) ((Graphics2D)g2).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,.5f));
			if (lm!=null) lm.draw(g2);
			Color backCol = getPaintBackColor(selected);
			g.setColor(backCol);
			g.drawOval(ix - w/2, iy - h / 2, w, h );
		}		    
	}
	public void actionPerformed(ActionEvent e) {	
		expanded=!expanded;
	}
	public void extendNodePopup(PopupMenu m, MutaGraphPanel p){		
		MenuItem i=null;
		if (expanded) {			
			i=new MenuItem("Karte verstecken");			
		} 
		else if (lm!=null)  i=new MenuItem("Karte anzeigen");
		if (i!=null){
			i.addActionListener(this);						
			m.add(i); 	
		}
	}
	/* (non-Javadoc)
	 * @see org.dronus.graph.gui.NodeRenderer#defaultAction()
	 */
	public void defaultAction() {
		new Happ(n.getLabel());
	}
}
