
package org.dronus.graph.gui.interact;

import org.dronus.graph.gui.*;

import  java.awt.event.*;

/** TGAbstractClickUI allows one to write interfaces that deal with
  * mouse clicks.
  *   
  * @author   Alexander Shapiro                                        
  * @version  1.21  $Id: TGAbstractClickUI.java,v 1.10 2002/04/01 05:52:38 x_ander Exp $
  */
public abstract class GraphAbstractClickUI extends GraphUserInterface {

     private ACUIMouseListener ml;
     private GraphPanel tgPanel;
     
     public GraphAbstractClickUI() { // Instantiate this way if you want to finish after one click
         tgPanel=null;
         ml= null;
     }
     
     public GraphAbstractClickUI(GraphPanel tgp) { // Instantiate this way to keep listening for clicks until
                                             // deactivate is called
          tgPanel=tgp;
          ml = new ACUIMouseListener();
      }

     public final void activate() {
         if (tgPanel!=null && ml!=null) tgPanel.addMouseListener(ml);
     }
         
    public final void activate(MouseEvent e) {
        mouseClicked(e);
    }
        
    public final void deactivate() { 
        if (tgPanel!=null && ml!=null) tgPanel.removeMouseListener(ml);
        super.deactivate(); //To activate parentUI from TGUserInterface
    }
    
    public abstract void mouseClicked(MouseEvent e);
    
    private class ACUIMouseListener extends MouseAdapter {    
        public void mouseClicked(MouseEvent e) {
            GraphAbstractClickUI.this.mouseClicked(e);
            if (selfDeactivate) deactivate();
        }
    }

} // end com.touchgraph.graphlayout.interaction.TGAbstractClickUI
