
package org.dronus.graph.gui.interact;

import org.dronus.graph.gui.*;

import java.awt.Scrollbar;
import  java.awt.event.*;


public class ZoomScroll {

    protected ZoomLens zoomLens;
    private Scrollbar zoomSB;
    private GraphPanel tgPanel;

  // ............

   /** Constructor with TGPanel <tt>tgp</tt>.
     */
    public ZoomScroll( GraphPanel tgp ) {
        tgPanel=tgp;
        zoomSB = new Scrollbar(Scrollbar.HORIZONTAL, -10, 4, -31, 19);
        zoomSB.addAdjustmentListener(new zoomAdjustmentListener());
        zoomLens=new ZoomLens();
    }

    public Scrollbar getZoomSB() { return zoomSB; }

    public ZoomLens getLens() { return zoomLens; }

    private class zoomAdjustmentListener implements AdjustmentListener {
        public void adjustmentValueChanged(AdjustmentEvent e) {
        tgPanel.repaintAfterMove();
        }
    }

    class ZoomLens extends AbstractLens {
        protected void applyLens(Point2D p) {
            p.x=p.x*Math.pow(2,zoomSB.getValue()/10.0);
            p.y=p.y*Math.pow(2,zoomSB.getValue()/10.0);

        }
        protected void undoLens(Point2D p) {
            p.x=p.x/Math.pow(2,zoomSB.getValue()/10.0);
            p.y=p.y/Math.pow(2,zoomSB.getValue()/10.0);
        }
    }

} // end com.touchgraph.graphlayout.interaction.ZoomScroll
