package org.dronus.hansi;
import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.util.zip.*;

import javax.imageio.*;
import javax.imageio.stream.*;
import java.io.*;


public class ImageLoader{
	static HashMap imgs=new HashMap();
	static HashSet marker=new HashSet();
	static ZipFile zip;
	private static String basedir="", extension=".jpg";
	
	public static void setBaseDir(String _base) throws IOException{
		basedir=_base;
		if (basedir.matches(".*?\\.zip")){
			if (zip==null) zip=new ZipFile(basedir);
		}else zip=null;
		//	ImageIO.setUseCache(true);			
	}
	public static void free(){
		imgs=new HashMap();
		mark();
		System.gc();		
	}
	public static void mark(){
		marker=new HashSet();
	}
	public static void optimize(){
		boolean kill=false;
		Iterator it=imgs.entrySet().iterator();
		//System.out.print("Images before "+imgs.size());
		while(it.hasNext())
			if (!marker.contains(((Map.Entry)it.next()).getValue())) {
				kill=true;
				it.remove();
				
			}
		//System.out.print(","+imgs.size()+" after optimization."); 
		if (kill) System.gc();	  		
	};
	public static BufferedImage getImg(String s) {
		if (s==null) return null;
		BufferedImage img=null;		
		if (!imgs.containsKey(s)){			
			String filename=s.replace('','a').replace('','o').replace('','u').replace('','s');			
			try{
				ImageInputStream st;
				if (!filename.matches(".*?\\.[^/]+"))	filename+=extension;					
				if (zip!=null){
					ZipEntry ze=zip.getEntry(filename);
					if (ze==null) throw new RuntimeException("notInZip:"+filename);
					st=new MemoryCacheImageInputStream(zip.getInputStream(ze));
				}else
					st=new MemoryCacheImageInputStream((ImageLoader.class).getClassLoader().getResource(basedir+filename).openStream());								
				img=ImageIO.read(st);			
			}
			catch (IOException e) {System.out.println("ImageLoader: no file:"+basedir+filename);e.printStackTrace();}
			imgs.put(s,img);
		} else 
			img =(BufferedImage)imgs.get(s);
		marker.add(img);
		return img;
	}

	public static HashMap loadImages()	{
		imgs=new HashMap();	
		File[] list=(new File(basedir)).listFiles();
		for (int i=0; i<list.length; i++){
			try{				
				String n=list[i].getName();				
				Image img=ImageIO.read(list[i]);
				if (img!=null) imgs.put(n.substring(0, n.length()-4) , img);
			} catch (Exception e) {System.out.print(e);}
		}
		System.out.println(imgs.keySet().toString());						
		return imgs;
	}	
}
