package org.dronus.hansi;
import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.*;
import java.io.*;

import java.awt.Image;

/*
 * Created on 04.03.2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

/**
 * @author Jan-Gunnar unter Aufsicht von Paul
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class LeinMap extends Canvas {
	String blockbase;
	static HashMap map;
	BufferedImage bufferimg=(BufferedImage)null;
//	int w,h;
	double posx=20,posy=20;
	int basesize=1600;
	int miplevel;
	boolean isPainting;
	boolean hud=true, optimize=true;
	boolean locked=false;
	
	class MapCoord{
		public int x,y; 
		MapCoord(int _x, int _y){
			x=_x;
			y=_y;
		}
		public int hashCode(){
			return x^y ; 
		}
		public boolean equals(Object o){
			if (o instanceof MapCoord)
				return  ( ((MapCoord)o).x==x && ((MapCoord)o).y==y );
			return false;
		}		
	}
	BufferedImage getBufferImg(){
		if (bufferimg==null  || bufferimg.getWidth()!=getWidth() || bufferimg.getHeight()!=getHeight()) bufferimg=(BufferedImage)createImage(getWidth(),getHeight());
		return bufferimg;
	}
	public void setOptimize(boolean _opt){optimize=_opt;}	
	public void setHUD(boolean _hud){
		hud=_hud;
		repaint();
	}
	public void setMipLevel(int level){
		if (miplevel==level) return;
		miplevel=level;
		ImageLoader.free();
		repaint();
	}

	class MouseScroll extends MouseAdapter implements MouseMotionListener{
		int lastx,lasty;
		public void mousePressed(MouseEvent e) {
			lastx=e.getX();
			lasty=e.getY();
		}
//		public void mouseReleased(MouseEvent e) {}
		public void mouseMoved(MouseEvent e) {}
		public void mouseDragged(MouseEvent e) {
			if (locked) return;
			int dx=e.getX()-lastx;
			int dy=e.getY()-lasty;
			double s=(1<<miplevel)/(double)basesize;
			posx-=(double)dx*s;
			posy-=(double)dy*s;
			lastx+=dx;
			lasty+=dy;
			repaint();
		}
	}
	
	
	public LeinMap(String _blockbase, File mapfile){
		
		blockbase=_blockbase;
				
		if (map==null) try {
			ImageLoader.setBaseDir(blockbase);
			BufferedReader  r=new BufferedReader(new InputStreamReader (new FileInputStream(mapfile)));
			String line;
			map=new HashMap(50,.5f); 
			while ((line=r.readLine())!=null){
				String[] data=line.split(",");
				int x=new Integer(data[0]).intValue(),y=new Integer(data[1]).intValue();
/*				w=(x>w? x : w);
				h=(y>h? y : h); 
*/				map.put(new MapCoord(x,y),new Integer(data[2]));
			}			
		} catch (IOException e) {
			e.printStackTrace();
		}
		MouseScroll ms=new MouseScroll();
		addMouseListener(ms);			
		addMouseMotionListener(ms);
		addKeyListener(new KeyAdapter(){
			 public void keyReleased(KeyEvent e) {			 	
				switch (e.getKeyCode()){
					case KeyEvent.VK_PLUS:
					case KeyEvent.VK_ADD:
						if (miplevel>0) setMipLevel(miplevel-1);
						break;
					case KeyEvent.VK_SUBTRACT:
					case KeyEvent.VK_MINUS:
						if ( ((basesize>>(miplevel)) & 1) ==0) setMipLevel(miplevel+1);
						break;
					case KeyEvent.VK_H:
						setHUD(!hud);
						break;
					case KeyEvent.VK_C:
						Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection((new GK(posx,posy)).toString()),null);
						break;	
					case KeyEvent.VK_V:
						Transferable t=Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null);
						try {
							GK gk=new GK((String)t.getTransferData(DataFlavor.stringFlavor));
							posx=gk.getRasterX(); posy=gk.getRasterY();
							repaint();
						} catch (Exception e1) {
							e1.printStackTrace();
						}
						break;
				}
			  }
		 });
		setMipLevel(6);					
	}
	public void setGK(String s) throws NumberFormatException{
		GK gk=new GK(s);
		posx=gk.getRasterX(); posy=gk.getRasterY();
	}

	public Dimension getPreferredSize() {
		return new Dimension(600,400);
	}
	
	static String pad(int i, int digits){
		 String s="";
		 s+=i;
		 while (s.length()<digits) s="0"+s;
		 return s;
	}
	public void update(Graphics g){	paint(g);	} // weil sonst clear(); erfolgt
	public void draw(Graphics g){
		Object bild;
			int s=basesize>>miplevel;
			double w=getWidth(), h=getHeight();			
			int cx=(int)w/2, cy=(int)h/2;
			w/=s;h/=s;
			if (s==0) g.drawString("max resolution penetrated",cx, cy);
			else{
				double px=(posx-(cx/(double)s)), py=(posy-(cy/(double)s));
				Image img=null;
				if (optimize) ImageLoader.mark();
				double fx=px-(int)px,fy=py-(int)py;
				for (int x=0; x<=(w+fx); x++)
					for (int y=0; y<=(h+fy); y++)
						if ((bild=map.get(new MapCoord((int)px+x,(int)py+y)))!=null)
							if ((img=ImageLoader.getImg("block"+(miplevel+1)+"/test_block"+pad(((Integer)bild).intValue(),5)))!=null) 
								g.drawImage(img,x*s-(int)(fx*s),y*s-(int)(fy*s),null);
				if (optimize) ImageLoader.optimize();
				if (img==null) g.drawString("mip level unexists",cx, cy); 
			}
	}
	public void paint(Graphics _g) {
		if (isPainting) return;
		Graphics g=getBufferImg().getGraphics();
		g.clearRect(0,0,getWidth(),getHeight());
		isPainting=true;
		draw(g);		
		if (hud) {
			g.setColor(Color.RED);
			int cx=getWidth()/2, cy=getHeight()/2;
			g.drawLine(cx,cy,cx,cy);
			g.drawString("|@"+(new GK(posx,posy)).toString(),cx,cy);
		}
		_g.drawImage(bufferimg,0,0,null); 		
		isPainting=false;		
	}
	public void setLocked(boolean b) {
		locked=b;
	}
}
